/****                            ****/
/** Utility to handle echo device  **/
/****                            ****/

////
// Include files
////

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>
#include <termios.h>
#include <libusb-1.0/libusb.h>

#include "libusb.h"

////
// Constants
////

#define		TYPE_ECHO	0
#define		EP_INSIZE 1
#define		EP_OUTSIZE 10
#define		DEFAULT_TIMEOUT	1000

////
// Structures
////

////
// Global variables
////

DeviceID ID_echo[]={
  {0x4242,0x0002,TYPE_ECHO},
  {-1,-1}
};

////
// Fonctions
////

// Tests du périphérique USB

int test_echo_v2(void){
  unsigned char token[EP_OUTSIZE+2] = {0};
  unsigned char bytes[EP_INSIZE];
  
  if(nb_devices > 0){
    if(devices[0].in[0].type != LIBUSB_TRANSFER_TYPE_INTERRUPT) return -2;
    int in = devices[0].in[0].address;
    if(devices[0].out[0].type != LIBUSB_TRANSFER_TYPE_INTERRUPT) return -3;
    int out = devices[0].out[0].address;
    int size = 0, ressnd, resrcv, i;

    while(1){
      // Get password from user
      printf("Enter password: ");
      fflush(stdin);
      fgets((char*)token, EP_OUTSIZE+2, stdin);
      
      token[strlen(token)] = 0;
      
      ressnd=libusb_interrupt_transfer(devices[0].handle,out,token,EP_OUTSIZE,&size,DEFAULT_TIMEOUT);
      printf("Résultat envoi=%d taille envoyée=%d\n",ressnd,size);
      for(i=0;i<EP_OUTSIZE;i++) printf("%02x ",token[i]);
      printf("\n");
      sleep(1);
      resrcv=libusb_interrupt_transfer(devices[0].handle,in|LIBUSB_ENDPOINT_IN,bytes,EP_INSIZE,&size,DEFAULT_TIMEOUT);
      printf("Résultat réception=%d taille réception=%d\n",resrcv,size);
      for(i=0;i<EP_INSIZE;i++) printf("%02x ",bytes[i]);
      printf("\n");
      sleep(1);
    }
    return 0;
  }
  return -1;
}

// Main procedure

int main(void){
  scan_for_devices(ID_echo);
  configure_devices();
  int result = test_echo_v2();
  printf("Résultat du test : %d\n", result);
  close_devices();
  exit(0);
}
